VERSION 5.00
Begin VB.Form frmProvaEige 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Prova modEige"
   ClientHeight    =   4380
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8145
   Icon            =   "frmProvaEige.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   4380
   ScaleWidth      =   8145
   StartUpPosition =   3  'Windows Default
   Begin VB.Label zlblAutore 
      Alignment       =   1  'Right Justify
      BackStyle       =   0  'Transparent
      Caption         =   "F. Languasco fecit 7/7/2001"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   6120
      TabIndex        =   6
      Top             =   4140
      Width           =   1815
   End
   Begin VB.Label lblAutoVet 
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1575
      Left            =   180
      TabIndex        =   5
      Top             =   2460
      Width           =   7755
      WordWrap        =   -1  'True
   End
   Begin VB.Label zLabel08 
      BackStyle       =   0  'Transparent
      Caption         =   "Autovettori:"
      Height          =   255
      Left            =   180
      TabIndex        =   4
      Top             =   2220
      Width           =   975
   End
   Begin VB.Label lblAutoValori 
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1575
      Left            =   5640
      TabIndex        =   3
      Top             =   540
      Width           =   2295
   End
   Begin VB.Label zLabel09 
      BackStyle       =   0  'Transparent
      Caption         =   "Autovalori:"
      Height          =   255
      Left            =   5640
      TabIndex        =   2
      Top             =   300
      Width           =   975
   End
   Begin VB.Label lblOrg 
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1575
      Left            =   180
      TabIndex        =   1
      Top             =   540
      Width           =   4155
   End
   Begin VB.Label zLabel01 
      BackStyle       =   0  'Transparent
      Caption         =   "Matrice originale:"
      Height          =   255
      Left            =   180
      TabIndex        =   0
      Top             =   300
      Width           =   2355
   End
End
Attribute VB_Name = "frmProvaEige"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'===========================================================
' Descrizione.....: Form di prova per le routines del modulo
'                   modEige.bas.
' Nome dei Files..: frmProvaEige.frm, frmProvaEige.frx
'                   modEige.bas, Complex.bas
' Data............: 8/7/2001
' Versione........: 1.0 a 32 bits.
' Sistema.........: VB6 sotto Windows NT.
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://members.xoom.it/flanguasco/
'                   http://www.mclink.it/personal/MC7061/
'===========================================================
'
'   La matrice di prova e' definita come o() nel Form_Load
'   di frmMatrici e successivamente passata a frmProvaEige.Apri.
'
'   In frmProvaEige.Apri vi sono pure gli esempi d' uso delle
'   routines di modEige.bas.
'
Option Explicit

Public Sub Apri(o#())
'
'
    Dim I&, J&, K&, N&, Vm$, Ierr&, Matz&
    Dim a#(), wr#(), wi#(), z#()
    Dim aval() As Complex, avet() As Complex
'
    Me.Show
'
    ' Scrive la matrice originale:
    a() = o()
    N = UBound(a)
    For I = 1 To N
        For J = 1 To N - 1
            Vm$ = Format$(a(I, J), "#0.000")
            If Left$(Vm$, 1) <> "-" Then Vm$ = "+" & Vm$
            lblOrg = lblOrg & Vm$ & " "
        Next J
        Vm$ = Format$(a(I, N), "#0.000")
        If Left$(Vm$, 1) <> "-" Then Vm$ = "+" & Vm$
        lblOrg = lblOrg & Vm$ & vbNewLine
    Next I
'
    ' Calcola gli autovalori e gli autovettori,
    ' reali e complessi, di a():
    Matz = 1
    rg a#(), wr#(), wi#(), Matz&, z#(), Ierr&
'
    ' Sistema gli autovalori tornati da rg nel vettore aval()
    ' e gli autovettori nella matrice avet(): gli autovettori
    ' sono le colonne di avet(). aval() e avet() sono definiti
    ' complessi.
'
    ' Autovalori:
    ReDim aval(1 To N)
    For I = 1 To N
        aval(I) = CCmp(wr(I), wi(I))
    Next I
'
    ' Autovettori.
    ' Vedere il commento iniziale a rg
    ' per il formato dei valori in z():
    ReDim avet(1 To N, 1 To N)
    J = 1
    For K = 1 To N
        If wi(K) > 0# Then
            ' Il corrispondente autovalore e' complesso
            ' e quindi costruisco due autovettori complessi
            ' e coniugati:
            For I = 1 To N
                avet(I, K) = CCmp(z(I, J), z(I, J + 1))
                avet(I, K + 1) = CCmp(z(I, J), -z(I, J + 1))
            Next I
            J = J + 2
        ElseIf wi(K) = 0# Then
            ' Il corrispondente autovalore e' reale
            ' e quindi costruisco un solo autovettore
            ' reale:
            For I = 1 To N
                avet(I, K) = CCmp(z(I, J), 0#)
            Next I
            J = J + 1
        End If
    Next K
'
    ' Scrive gli autovalori:
    For I = 1 To N
        Vm$ = CFormat$(aval(I), "#0.000")
        lblAutoValori = lblAutoValori & Vm$ & vbNewLine
    Next I
'
    ' Scrive gli autovettori:
    For I = 1 To N
        For J = 1 To N - 1
            Vm$ = CFormat$(avet(I, J), "#0.000")
            lblAutoVet = lblAutoVet & Vm$ & " | "
        Next J
        Vm$ = CFormat$(avet(I, N), "#0.000")
        lblAutoVet = lblAutoVet & Vm$ & vbNewLine
    Next I
'
'
'
End Sub

Private Sub Form_Unload(Cancel As Integer)
'
'
    Set frmProvaEige = Nothing
'
'
'
End Sub


